/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef pc_textmode_h
#define pc_textmode_h

#include <cairo.h>
#include <stdint.h>

#include "cons_if.h"

/* The blink is on for 16 frames, then off for 16 frames.
   This emulates a frame rate of 60Hz. */
#define BLINK_DURATION (16.0/60)

typedef enum{
    S_ON,
    S_OFF,
    S_ICE
}AbydosConsoleState;

extern const uint32_t abydos_cga_palette16[16];

cairo_bool_t abydos_console_has_blink(Console *cons);
cairo_surface_t *abydos_image_surface_from_console(Console *cons, AbydosConsoleState state, int letter_spacing);

#endif /* pc_textmode_h */
