#ifndef doc_frame_tags_h
#define doc_frame_tags_h

#include <vector>

namespace doc{
    class FrameTag;
    class Sprite;

    class FrameTags{
        typedef std::vector<FrameTag*> List;
        typedef List::iterator iterator;
        typedef List::const_iterator const_iterator;
    private:
        Sprite *_sprite;
        List _tags;
    public:
        FrameTags(Sprite* s){ _sprite = s; }
        void add(FrameTag*);

        iterator begin() { return _tags.begin(); }
        iterator end() { return _tags.end(); }
        const_iterator begin() const { return _tags.begin(); }
        const_iterator end() const { return _tags.end(); }

        std::size_t size() const { return _tags.size(); }
    };
}

#endif /* doc_frame_tags_h */
