/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef cgmdraw_h
#define cgmdraw_h

#include <loa-buffer.h>
#include <nile.h>

#include "cgmtypes.h"
#include "elements.h"

typedef struct{
    void(*InsertPage)(void *userdata, cgm_attributes_t*);
    void(*BeginGroup)(void *userdata);
    void(*EndGroup)(void *userdata);
    void(*EndGrouping)(void *userdata);
    void(*DrawBitmap)(void *userdata, const loa_point_t*, nile_t* );
    void(*DrawText)(void *userdata, rect_t *rect, cgm_attributes_t*, const char*, FinalFlag);
    void(*AppendText)(void *userdata, cgm_attributes_t*, const char*, FinalFlag);

    void(*stroke_shape)(void *userdata, cgm_attributes_t*, const loa_object_t*);
    void(*fill_shape)(void *userdata, cgm_attributes_t*, const loa_object_t*);

    void(*FirstOutPut)(void *userdata, int width, int height, int xadd, int yadd);
    void(*BeginFigure)(void *userdata);
    void(*CloseRegion)(void *userdata);
    void(*NewRegion)(void *userdata);
    void(*EndFigure)(void *userdata);
    void(*RegPolyLine)(void *userdata, const path_t* , bool bReverse );
    void(*SetGradientOffset)(void *userdata, long nHorzOfs, long nVertOfs );
    void(*SetGradientAngle)(void *userdata, long nAngle );
    void(*SetGradientDescriptor)(void *userdata, color_t nColorFrom, color_t nColorTo );
    void(*SetGradientStyle)(void *userdata, color_t nStyle );
}cgm_interface_t;

#endif /* cgmdraw_h */
