/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef loa_matrix_h
#define loa_matrix_h

#include <loa-buffer.h>

typedef struct{
    double xx;
    double yx;
    double xy;
    double yy;
    double x0;
    double y0;
}loa_matrix_t;

void loa_matrix_set_identity(loa_matrix_t*);
void loa_matrix_multiply(loa_matrix_t*, const loa_matrix_t*);
void loa_matrix_translate(loa_matrix_t*, double tx, double ty);
void loa_matrix_scale(loa_matrix_t*, double sx, double sy);
void loa_matrix_rotate(loa_matrix_t*, double a);
double loa_matrix_apply_x(const loa_matrix_t*, double x);
double loa_matrix_apply_y(const loa_matrix_t*, double y);
void loa_matrix_apply_point(const loa_matrix_t*, loa_point_t*);

#endif /* loa_matrix_h */

