/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef teletext_console_h
#define teletext_console_h

#include <cairo.h>
#include <stdint.h>

#include "cons_buf.h"

#define TT_CAIRO_BITS16

#define TT_SCREEN_WIDTH 40
#define TT_SCREEN_HEIGHT 25
#define TT_CHAR_WIDTH 12
#define TT_CHAR_HEIGHT 10

#ifdef TT_CAIRO_BITS16
typedef uint16_t teletext_cairo_color_t;
#else
typedef uint32_t teletext_cairo_color_t;
#endif

typedef enum{
    S_ON,
    S_OFF
}TeletextConsoleState;

extern const teletext_cairo_color_t abydos_teletext_palette[8];

cairo_bool_t teletext_console_has_flash(Console *cons);
cairo_surface_t *abydos_image_surface_create_from_teletext_console(Console *cons,TeletextConsoleState state);

#endif /* teletext_console_h */
