/*
 * Copyright (C) 2017  Teemu Suutari
 * Copyright (C) 2020  Magnus Bergman <magnus@snisurset.net>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * * Redistributions of source code must retain the above copyright notice, this
 *   list of conditions and the following disclaimer.
 *
 * * Redistributions in binary form must reproduce the above copyright notice,
 *   this list of conditions and the following disclaimer in the documentation
 *   and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 */
#ifndef RANGEDECODER_HPP
#define RANGEDECODER_HPP

#include <cstdint>

// used by too many compressors...
class RangeDecoder
{
public:
	class BitReader
	{
	public:
		BitReader();
		virtual ~BitReader();

		virtual uint32_t readBit()=0;
	};

	RangeDecoder(BitReader &bitReader,uint16_t initialValue);
	~RangeDecoder();

	uint16_t decode(uint16_t length);
	void scale(uint16_t newLow,uint16_t newHigh,uint16_t newRange);

private:
	BitReader			&_bitReader;

	uint16_t			_low=0;
	uint16_t			_high=0xffffU;
	uint16_t			_stream;
};

#endif
