/*
 * Author: Magnus Bergman <magnus@snisurset.net>
 *
 * This file is public domain.
 */
#ifndef stream_h
#define stream_h

#include <cstdint>
#include <exception>

class Stream{
public:
    class Error : public std::exception {};
    class OverrunError : public Error {};

    size_t getOffset() const {return _currentOffset;}
protected:
    Stream(size_t startOffset, size_t currentOffset, size_t endOffset);
    ~Stream(){}

    size_t _startOffset;
    size_t _currentOffset;
    size_t _endOffset;
};

#endif /* stream_h */
