/*
 * Copyright (C) 2021  Magnus Bergman <magnus@snisurset.net>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 * 1. Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */
#include "nil-pctext.h"

#include "vgafont16.h"

void
nil_pctext_draw_character(nile_t *ni, int x, int y, int ch, uint32_t bg, uint32_t fg, int letter_spacing)
{
    uint8_t *fontchar = &vga_rom_16[ch*16];
    uint32_t *dst = (uint32_t*)(ni->pixels + x * ni->bpc + y * ni->stride);
    int rowskip = ni->stride/4 - letter_spacing;
    int ninth = letter_spacing>8 && ch>=192 && ch<224;
    for(y=0;y<16;++y){
        int pixels = *fontchar++;
        for(x=0;x<8;++x){
            pixels <<= 1;
            *dst++ = pixels&0x100 ? fg : bg;
        }
        if(letter_spacing>8)
            *dst++ = ninth && pixels&0x100 ? fg : bg;
        dst += rowskip;
    }
}
